searchData={"items":[{"type":"module","title":"LiveReact","doc":"See READ.md for installation instructions and examples.","ref":"LiveReact.html"},{"type":"function","title":"LiveReact.react/1","doc":"Render a React component.","ref":"LiveReact.html#react/1"},{"type":"module","title":"LiveReact.Reload","doc":"Utilities for easier integration with Vite in development","ref":"LiveReact.Reload.html"},{"type":"function","title":"LiveReact.Reload.vite_assets/1","doc":"Renders the vite assets in development, and in production falls back to normal compiled assets","ref":"LiveReact.Reload.html#vite_assets/1"},{"type":"function","title":"Attributes - LiveReact.Reload.vite_assets/1","doc":"* `assets` (`:list`) (required)","ref":"LiveReact.Reload.html#vite_assets/1-attributes"},{"type":"function","title":"Slots - LiveReact.Reload.vite_assets/1","doc":"* `inner_block` (required) - what should be rendered when Vite path is not defined.","ref":"LiveReact.Reload.html#vite_assets/1-slots"},{"type":"behaviour","title":"LiveReact.SSR","doc":"A behaviour for rendering React components server-side.\n\nTo define a custom renderer, change the application config in `config.exs`:\n\n    config :live_react, ssr_module: MyCustomSSRModule\n\nExposes a telemetry span for each render under key `[:live_react, :ssr]`","ref":"LiveReact.SSR.html"},{"type":"function","title":"LiveReact.SSR.render/2","doc":"","ref":"LiveReact.SSR.html#render/2"},{"type":"callback","title":"LiveReact.SSR.render/2","doc":"","ref":"LiveReact.SSR.html#c:render/2"},{"type":"type","title":"LiveReact.SSR.component_name/0","doc":"","ref":"LiveReact.SSR.html#t:component_name/0"},{"type":"type","title":"LiveReact.SSR.props/0","doc":"","ref":"LiveReact.SSR.html#t:props/0"},{"type":"type","title":"LiveReact.SSR.render_response/0","doc":"A render response which should have shape\n\n%{\n  html: string,\n}","ref":"LiveReact.SSR.html#t:render_response/0"},{"type":"module","title":"LiveReact.SSR.NodeJS","doc":"Implements SSR by using `NodeJS` package.\n\nUnder the hood, it invokes \"render\" function exposed by `server.js` file.\nYou can see how `server.js` is created by looking at `assets.deploy` command\nand `package.json` build-server script.","ref":"LiveReact.SSR.NodeJS.html"},{"type":"function","title":"LiveReact.SSR.NodeJS.render/2","doc":"","ref":"LiveReact.SSR.NodeJS.html#render/2"},{"type":"function","title":"LiveReact.SSR.NodeJS.server_path/0","doc":"","ref":"LiveReact.SSR.NodeJS.html#server_path/0"},{"type":"module","title":"LiveReact.SSR.ViteJS","doc":"Implements SSR by making a POST request to `http://{:vite_host}/ssr_render`.\n\n`ssr_render` is implemented as a Vite plugin. You have to add it to the `vite.config.js` plugins section.\n\n```javascript\nimport liveReactPlugin from \"live_react/vite-plugin\";\n\n{\n  publicDir: \"static\",\n  plugins: [react(), liveReactPlugin()],\n  // ...\n}","ref":"LiveReact.SSR.ViteJS.html"},{"type":"function","title":"LiveReact.SSR.ViteJS.render/2","doc":"","ref":"LiveReact.SSR.ViteJS.html#render/2"},{"type":"function","title":"LiveReact.SSR.ViteJS.vite_path/1","doc":"A handy utility returning path relative to Vite JS host.","ref":"LiveReact.SSR.ViteJS.html#vite_path/1"},{"type":"task","title":"mix live_react.setup","doc":"Copies files from assets/copy of the live_react dependency to phoenix project assets folder","ref":"Mix.Tasks.LiveReact.Setup.html"},{"type":"extras","title":"README","doc":"[![Hex.pm](https://img.shields.io/hexpm/v/live_react.svg)](https://hex.pm/packages/live_react)\n[![Hexdocs.pm](https://img.shields.io/badge/docs-hexdocs.pm-purple)](https://hexdocs.pm/live_react)\n[![GitHub](https://img.shields.io/github/stars/mrdotb/live_react?style=social)](https://github.com/mrdotb/live_react)\n\n# LiveReact\n\nReact inside Phoenix LiveView.\n\n![logo](https://github.com/mrdotb/live_react/blob/main/logo.svg?raw=true)","ref":"readme.html"},{"type":"extras","title":"Features - README","doc":"- ⚡ **End-To-End Reactivity** with LiveView\n- 🔋 **Server-Side Rendered** (SSR) React\n- 🦄 **Tailwind** Support\n- 💀 **Dead View** Support\n- 🐌 **Lazy-loading** React Components\n- 🚀 **Amazing DX** with Vite","ref":"readme.html#features"},{"type":"extras","title":"Resources - README","doc":"- [Demo](https://live-react-examples.fly.dev/simple)\n- [HexDocs](https://hexdocs.pm/live_react)\n- [HexPackage](https://hex.pm/packages/live_react)\n- [Phoenix LiveView](https://github.com/phoenixframework/phoenix_live_view)\n- [Installation](/guides/installation.md)\n- [Deployment](/guides/deployment.md)\n- [Development](/guides/development.md)\n- [SSR](/guides/ssr.md)","ref":"readme.html#resources"},{"type":"extras","title":"Example - README","doc":"Visit the [demo website](https://live-react-examples.fly.dev/simple) to see examples of what you can do with LiveReact.\n\nYou can also check out the [PhoenixAnalytics project](https://github.com/lalabuy948/PhoenixAnalytics) for a real-world example.","ref":"readme.html#example"},{"type":"extras","title":"Why LiveReact - README","doc":"Phoenix LiveView enables rich, real-time user experiences with server-rendered HTML.\nIt works by communicating any state changes through a websocket and updating the DOM in realtime.\nYou can get a really good user experience without ever needing to write any client side code.\n\nLiveReact builds on top of Phoenix LiveView to allow for easy client side state management while still allowing for communication over the websocket.","ref":"readme.html#why-livereact"},{"type":"extras","title":"Installation - README","doc":"see [Installation](/guides/installation.md)","ref":"readme.html#installation"},{"type":"extras","title":"Roadmap 🎯 - README","doc":"- [ ] Pre-build SSR components for static props\n- [ ] `useLiveForm` - an utility to efforlessly use Ecto changesets & server-side validation, similar to HEEX\n- [ ] Add support for Phoenix streams as props","ref":"readme.html#roadmap"},{"type":"extras","title":"Credits - README","doc":"I was inspired by the following libraries:\n\n- [LiveVue](https://github.com/Valian/live_vue)\n- [LiveSvelte](https://github.com/woutdp/live_svelte)\n\nI had a need for a similar library for React and so I created LiveReact 👍","ref":"readme.html#credits"},{"type":"extras","title":"Installation","doc":"# Installation\n\nLiveReact replaces `hex esbuild` with [Vite](https://vite.dev/) for both client side code and SSR to achieve a better development experience. Why ?\n\n- Vite provides a best-in-class Hot-Reload functionality and offers [many benefits](https://vitejs.dev/guide/why#why-vite) not present in esbuild\n- `hex esbuild` package doesn't support plugins, while it's possible to do ssr with `hex esbuild` (check [v0.2.0-rc-0](https://github.com/mrdotb/live_react/tree/v0.2.0-rc.0)) the SSR in development is broken.\n- the integration to react and ssr is more documented with Vite\n\nIn production, we'll use [elixir-nodejs](https://github.com/revelrylabs/elixir-nodejs) for SSR. If you don't need SSR, you can disable it with one line of code. TypeScript will be supported as well.","ref":"installation.html"},{"type":"extras","title":"Steps - Installation","doc":"0. install nodejs (I recommend [mise](https://mise.jdx.dev/))\n\n1. Add `live_react` to your list of dependencies in `mix.exs` and run `mix deps.get`\n\n```elixir\ndef deps do\n  [\n    {:live_react, \"~> 1.0.0-rc.2\"},\n    {:nodejs, \"~> 3.1\"} # if you want to use SSR in production\n  ]\nend\n```\n\n2. Add a config entry to your `config/dev.exs`\n\n```elixir\nconfig :live_react,\n  vite_host: \"http://localhost:5173\",\n  ssr_module: LiveReact.SSR.ViteJS,\n  ssr: true\n```\n\n3. Add a config entry to your `config/prod.exs`\n\n```elixir\nconfig :live_react,\n  ssr_module: LiveReact.SSR.NodeJS,\n  ssr: true # or false if you don't want SSR in production\n```\n\n4. Add `import LiveReact` in `html_helpers/0` inside `/lib/ _web.ex` like so:\n\n```elixir\n# /lib/ _web.ex\n\ndefp html_helpers do\n  quote do\n\n    # ...\n\n    import LiveReact # <-- Add this line\n\n    # ...\n\n  end\nend\n```\n\n5. LiveReact comes with a handy mix task to setup all the required files. It won't alter any files you already have in your project, you need to adjust them on your own by looking at the [sources](https://github.com/mrdotb/live_react/tree/main/assets/copy). Additional instructions how to adjust `package.json` can be found at the end of this page.\n\nIt will create:\n\n- `package.json`\n- vite, typescript and postcss configs\n- server entrypoint\n- react components root\n\n6. Run the following in your terminal\n\n```bash\nmix deps.get\nmix live_react.setup\nnpm install --prefix assets\n```\n\n7. Add the following to your `assets/js/app.js` file\n\n```javascript\n...\nimport topbar from \"topbar\" // instead of ../vendor/topbar\nimport { getHooks } from  \"live_react\";\nimport components from \"../react-components\";\nimport \"../css/app.css\" // the css file is handled by vite\n\nconst hooks = {\n  // ... your other hooks\n  ...getHooks(components),\n};\n\n...\n\nlet liveSocket = new LiveSocket(\"/live\", Socket, {\n  hooks: hooks, // <- pass the hooks\n  longPollFallbackMs: 2500,\n  params: { _csrf_token: csrfToken },\n});\n...\n```\n\n7. For tailwind support, make some addition to `content` in the `assets/tailwind.config.js` file\n\n```javascript\ncontent: [\n  ...\n    \"./react-components/**/*.jsx\", // <- if you are using jsx\n    \"./react-components/**/*.tsx\" // <- if you are using tsx\n],\n\n```\n\n8. Let's update `root.html.heex` to use Vite files in development. There's a handy wrapper for it.\n\n```html\n \n   \n   \n   \n \n```\n\n9. Update `mix.exs` aliases and remove `tailwind` and `esbuild` packages\n\n```elixir\ndefp aliases do\n[\n  setup: [\"deps.get\", \"assets.setup\", \"assets.build\"],\n  \"assets.setup\": [\"cmd --cd assets npm install\"],\n  \"assets.build\": [\n    \"cmd --cd assets npm run build\",\n    \"cmd --cd assets npm run build-server\"\n  ],\n  \"assets.deploy\": [\n    \"cmd --cd assets npm run build\",\n    \"cmd --cd assets npm run build-server\",\n    \"phx.digest\"\n  ]\n]\nend\n\ndefp deps do\n  [\n    # remove these lines, we don't need esbuild or tailwind here anymore\n    # {:esbuild, \"~> 0.8\", runtime: Mix.env() == :dev},\n    # {:tailwind, \"~> 0.2\", runtime: Mix.env() == :dev},\n  ]\nend\n```\n\n10. Remove esbuild and tailwind config from `config/config.exs`\n\n11. Update watchers in `config/dev.exs` to look like this\n\n```elixir\nconfig :my_app, MyAppWeb.Endpoint,\n  # ...\n  watchers: [\n    npm: [\"run\", \"dev\", cd: Path.expand(\"../assets\", __DIR__)]\n  ]\n```\n\n12. To make SSR working with `LiveReact.SSR.NodeJS` in production, you have to add this entry to your `application.ex` supervision tree to run the NodeJS server\n\nIf you don't want SSR in production, you can skip this step.\n\n```elixir\nchildren = [\n  ...\n  {NodeJS.Supervisor, [path: LiveReact.SSR.NodeJS.server_path(), pool_size: 4]},\n  # note Adjust the pool_size depending of the machine\n]\n```\n\n13. Confirm everything is working by rendering the default React component anywhere in your Dead or Live Views\n\n```elixir\n<.react name=\"Simple\" />\n```\n\n14. (Optional) enable [stateful hot reload](https://twitter.com/jskalc/status/1788308446007132509) of phoenix LiveViews - it allows for stateful reload across the whole stack 🤯. Just adjust your `dev.exs` to look like this - add `notify` section and remove `live|components` from patterns.\n\n```elixir\n# Watch static and templates for browser reloading.\nconfig :my_app, MyAppWeb.Endpoint,\n  live_reload: [\n    notify: [\n      live_view: [\n        ~r\"lib/my_app_web/core_components.ex$\",\n        ~r\"lib/my_app_web/(live|components)/.*(ex|heex)$\"\n      ]\n    ],\n    patterns: [\n      ~r\"priv/static/(?!uploads/).*(js|css|png|jpeg|jpg|gif|svg)$\",\n      ~r\"lib/my_app_web/controllers/.*(ex|heex)$\"\n    ]\n  ]\n```\n\nProfit! 💸","ref":"installation.html#steps"},{"type":"extras","title":"Adjusting your own package.json - Installation","doc":"Install these packages\n\n```bash\ncd assets\n\n# vite\nnpm install -D vite @vitejs/plugin-react\n\n# tailwind\nnpm install -D tailwindcss autoprefixer postcss @tailwindcss/forms\n\n# typescript\nnpm install -D typescript @types/react @types/react-dom\n\n# runtime dependencies\nnpm install --save react react-dom topbar ../deps/live_react ../deps/phoenix ../deps/phoenix_html ../deps/phoenix_live_view\n\n# remove topbar from vendor, since we'll use it from node_modules\nrm vendor/topbar.js\n```\n\nand add these scripts used by watcher and `mix assets.build` command\n\n```json\n{\n  \"private\": true,\n  \"type\": \"module\",\n  \"scripts\": {\n    \"dev\": \"vite --host -l warn\",\n    \"build\": \"tsc && vite build\",\n    \"build-server\": \"tsc && vite build --ssr js/server.js --out-dir ../priv/react-components --minify esbuild && echo '{\\\"type\\\": \\\"module\\\" } ' > ../priv/react-components/package.json\"\n  }\n}\n```","ref":"installation.html#adjusting-your-own-package-json"},{"type":"extras","title":"Deployment","doc":"# Deployment\n\n[Without SSR](#without-ssr)\n[With SSR](#with-ssr)","ref":"deployment.html"},{"type":"extras","title":"Without SSR - Deployment","doc":"The following steps are needed to deploy to Fly.io. This guide assumes that you'll be using Fly Postgres as your database. Further guidance on how to deploy to Fly.io can be found [here](https://fly.io/docs/elixir/getting-started/).\n\n1. Generate a `Dockerfile`:\n\n```bash\nmix phx.gen.release --docker\n```\n\n2. Modify the generated `Dockerfile` to install `curl`, which is used to install `nodejs` (version 19 or greater), and also add a step to install our `npm` dependencies:\n\n```diff\n# ./Dockerfile\n\n...\n\n# install build dependencies\n- RUN apt-get update -y && apt-get install -y build-essential git \\\n+ RUN apt-get update -y && apt-get install -y build-essential git curl \\\n    && apt-get clean && rm -f /var/lib/apt/lists/*_*\n\n+ # install nodejs for build stage\n+ RUN curl -fsSL https://deb.nodesource.com/setup_19.x | bash - && apt-get install -y nodejs\n\n...\n\nCOPY assets assets\n\n+ # install all npm packages in assets directory\n+ RUN cd /app/assets && npm install\n```\n\nNote: `nodejs` is installed in the build stage. This is because we need `nodejs` to install our `npm` dependencies.\n\n3. Launch your app with the Fly.io CLI:\n\n```bash\nfly launch\n```\n\n4. When prompted to tweak settings, choose `y`:\n\n```bash\n? Do you want to tweak these settings before proceeding? (y/N) y\n```\n\nThis will launch a new window where you can tweak your launch settings. In the database section, choose `Fly Postgres` and enter a name for your database. You may also want to change your database to the development configuration to avoid extra costs. You can leave the rest of the settings as-is unless you want to change them.\n\nDeployment will continue once you hit confirm.\n\n5. Once the deployment completes, run the following command to see your deployed app!\n\n```bash\nfly apps open\n```","ref":"deployment.html#without-ssr"},{"type":"extras","title":"With SSR - Deployment","doc":"See the [SSR guide](/guides/ssr.md) first to setup your project.\n\nThe following steps are needed to deploy to Fly.io. This guide assumes that you'll be using Fly Postgres as your database. Further guidance on how to deploy to Fly.io can be found [here](https://fly.io/docs/elixir/getting-started/).\n\n1. Generate a `Dockerfile`:\n\n```bash\nmix phx.gen.release --docker\n```\n\n2. Modify the generated `Dockerfile` to install `curl`, which is used to install `nodejs` (version 19 or greater), and also add a step to install our `npm` dependencies:\n\n```diff\n# ./Dockerfile\n\n...\n\n# install build dependencies\n- RUN apt-get update -y && apt-get install -y build-essential git \\\n+ RUN apt-get update -y && apt-get install -y build-essential git curl \\\n    && apt-get clean && rm -f /var/lib/apt/lists/*_*\n\n+ # install nodejs for build stage\n+ RUN curl -fsSL https://deb.nodesource.com/setup_19.x | bash - && apt-get install -y nodejs\n\n...\n\nCOPY assets assets\n\n+ # install all npm packages in assets directory\n+ RUN cd /app/assets && npm install\n\n...\n\n# start a new build stage so that the final image will only contain\n# the compiled release and other runtime necessities\nFROM ${RUNNER_IMAGE}\n\nRUN apt-get update -y && \\\n-  apt-get install -y libstdc++6 openssl libncurses5 locales ca-certificates \\\n+  apt-get install -y libstdc++6 openssl libncurses5 locales ca-certificates curl \\\n   && apt-get clean && rm -f /var/lib/apt/lists/*_*\n\n+ # install nodejs for production environment\n+ RUN curl -fsSL https://deb.nodesource.com/setup_19.x | bash - && apt-get install -y nodejs\n\n...\n```\n\nNote: `nodejs` is installed BOTH in the build stage and in the final image. This is because we need `nodejs` to install our `npm` dependencies and also need it when running our app.\n\n3. Launch your app with the Fly.io CLI:\n\n```bash\nfly launch\n```\n\n4. When prompted to tweak settings, choose `y`:\n\n```bash\n? Do you want to tweak these settings before proceeding? (y/N) y\n```\n\nThis will launch a new window where you can tweak your launch settings. In the database section, choose `Fly Postgres` and enter a name for your database. You may also want to change your database to the development configuration to avoid extra costs. You can leave the rest of the settings as-is unless you want to change them.\n\nDeployment will continue once you hit confirm.\n\n5. Once the deployment completes, run the following command to see your deployed app!\n\n```bash\nfly apps open\n```","ref":"deployment.html#with-ssr"},{"type":"extras","title":"Development","doc":"# Development\n\nThe easiest way to get started with development is to clone live_react and run the examples\n\n```bash\ngit clone https://github.com/mrdotb/live_react.git\ncd live_react_examples\n```","ref":"development.html"},{"type":"extras","title":"Server Side Rendering (SSR)","doc":"# Server Side Rendering (SSR)\n\n_Disclaimer_ SSR for React is not a simple topic and there is a lot of issue than can arise depending on what React components you are using. It also consume more ressource since a nodejs worker is needed for the rendering. This is a simple implementation that works for the components and library I have tested.","ref":"ssr.html"},{"type":"extras","title":"Project setup - Server Side Rendering (SSR)","doc":"⚠️ **Warning:** Server-side rendering (SSR) requires a Node.js worker. With a `pool_size` of 1 and the Phoenix app, you need at least **512MiB** of memory. Otherwise, the instance may experience **out-of-memory (OOM)** errors or severe slowness.\n\nSSR requires Node.js to render the javascript on server side. Add `nodejs` to your mix file.\n\n```elixir\ndefp deps do\n  [\n    {:nodejs, \"~> 3.1\"},\n    ...\n  ]\nend\n```\n\nAdd NodeJs.Supervisor to your `application.ex`\n\n```elixir\ndef start(_type, _args) do\n  children = [\n    ...\n    {NodeJS.Supervisor, [path: LiveReact.SSR.NodeJS.server_path(), pool_size: 4]},\n  ]\nend\n```\n\nAdd a config entry to your `config/prod.exs`\n\n```elixir\nconfig :live_react,\n  ssr_module: LiveReact.SSR.NodeJS,\n  ssr: true\n```\n\nFor complete deployment follow the [SSR deployment guide](/guides/deployment.md#with-ssr)","ref":"ssr.html#project-setup"},{"type":"extras","title":"Change Log","doc":"# Change Log\n\nAll notable changes to this project will be documented in this file.\nSee [Conventional Commits](Https://conventionalcommits.org) for commit guidelines.\n\n<!-- changelog -->\n\n## [v1.0.0-rc.2](https://github.com/mrdotb/live_react/compare/v1.0.0-rc.1...v1.0.0-rc.2) (2024-12-01)","ref":"changelog.html"},{"type":"extras","title":"Features: - Change Log","doc":"* Added SSR duration logging to example app","ref":"changelog.html#features"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* rename react folder to react-components to prevent Vite error\n\n## [v1.0.0-rc.1](https://github.com/mrdotb/live_react/compare/v1.0.0-rc.0...v1.0.0-rc.1) (2024-10-12)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* missing files in mix.exs to ship the js\n\n## [v1.0.0-rc.0](https://github.com/mrdotb/live_react/compare/v0.2.0-rc.0...v1.0.0-rc.0) (2024-10-05)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Breaking Changes: - Change Log","doc":"* vitejs: switch from Mix Esbuild to Vite.js\n\n## [v0.2.0-rc.0](https://github.com/mrdotb/live_react/compare/v0.2.0-rc.0...v0.2.0-rc.0) (2024-09-17)","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"Features - Change Log","doc":"* Add SSR support","ref":"changelog.html#features"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* ssr: remove compiler warning when using live_react without SSR","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"v0.1.0 (2024-06-29) - Change Log","doc":"Initial release","ref":"changelog.html#v0-1-0-2024-06-29"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,49]}}